package EDU.auburn.VGJ.gui;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import webflow.frontend.ModuleControls.CPanel;
import EDU.auburn.VGJ.frontend.*;

public class CardPanel extends Panel implements ActionListener, ItemListener {

   GraphWindow GWindow;
   GraphCanvas GraphCanvas_;
   CardLayout card = new CardLayout();
   CardLayout Acard = new CardLayout();
   Checkbox LoadIt, EditIt, SaveIt, RunIt, StopIt, ExitIt;
   Panel Modules, ActionCards;
   public CPanel Executor;
   String sm_URL;
   compgraph compgraph_;

   int i;

  CardPanel(GraphWindow GraphWindow_,GraphCanvas GCanvas, String SM_URL) {
      super();
      sm_URL = SM_URL; 

      GWindow = GraphWindow_;
      GraphCanvas_ = GCanvas;
      setLayout(new BorderLayout());

      Panel Action = new Panel();
      Action.setLayout(new GridLayout(2,3));
      Action.setBackground(Color.blue);
      Action.setForeground(Color.yellow);
      CheckboxGroup actiongroup = new CheckboxGroup();
      LoadIt = new Checkbox("Load", false, actiongroup);
      EditIt = new Checkbox("Edit", true, actiongroup);
      SaveIt = new Checkbox("Save", false, actiongroup);
      RunIt  = new Checkbox("Run", false, actiongroup);
      StopIt = new Checkbox("Stop", false, actiongroup);
      ExitIt = new Checkbox("Exit", false, actiongroup);

      ItemListener ActBox = new ItemListener() {
         public void itemStateChanged(ItemEvent e) {
	    String what = e.getItem().toString();
            System.err.println("checkbox selected: "+what);
            if(what.equals("Run")) {
                compgraph compgraph_ = 
                  new compgraph(GWindow,GraphCanvas_.graph_.nodeList_, sm_URL);
                compgraph_.tomnodelist();
            }
            if(what.equals("Stop")) {
	      if(compgraph_ != null) {compgraph_.destroyAll();}
	    }
            if(what.equals("Exit")) {
	      if(compgraph_ != null) {compgraph_.destroyAll();}
              GWindow.dispose();
	    }
     	    showActionCard(what);
         }
      };

      LoadIt.addItemListener(ActBox); 
      EditIt.addItemListener(ActBox); 
      SaveIt.addItemListener(ActBox); 
      RunIt.addItemListener(ActBox); 
      StopIt.addItemListener(ActBox); 
      ExitIt.addItemListener(ActBox); 

      Action.add(LoadIt); Action.add(EditIt); Action.add(SaveIt);
      Action.add(RunIt); Action.add(StopIt); Action.add(ExitIt);
      add(BorderLayout.NORTH,Action);

      ActionCards = new Panel();
      ActionCards.setLayout(Acard);

      Panel Creator = new Panel();
      Creator.setLayout(new BorderLayout());

      Panel superApp = new Panel();
      superApp.setBackground(Color.cyan);
      superApp.setLayout(new GridLayout(3,1));
      Font titleFont = new Font("Serif",Font.BOLD,14);
      Label AAA = new Label("Applications", Label.CENTER);
      Label BBB = new Label("Modules", Label.CENTER);
      AAA.setFont(titleFont);
      BBB.setFont(titleFont);

      Panel Applications = new Panel();
      Applications.setLayout(new GridLayout(1,3));
      Button QSbut = new Button("QS");
      Button Frogbut = new Button("Frog");
      Button Otherbut = new Button("Other");
      ActionListener AppButList = new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            String what = e.getActionCommand().toString();
            showContents(what);
         }
      };

      QSbut.addActionListener(AppButList);
      Frogbut.addActionListener(AppButList);
      Otherbut.addActionListener(AppButList);

      Applications.add(QSbut);
      Applications.add(Frogbut);
      Applications.add(Otherbut);
      superApp.add(AAA);
      superApp.add(Applications);
      superApp.add(BBB);
      
      Creator.add(BorderLayout.NORTH,superApp);

      Modules = new Panel();
      Modules.setLayout(card);

      Panel QS = new Panel();
      QS.setLayout(new GridLayout(4,2));

      Button[] QSbuttons = new Button[8];
      String[] QSnames = new String[8];
      ActionListener QSlistener = new ActionListener() {
          public void actionPerformed(ActionEvent e){
            String what = e.getActionCommand().toString();
            System.err.println("you pressed button "+what);
            GraphCanvas_.setCurrentLabel(what);
           
            System.err.println("simulate mouseDown event");
            Event ee = new Event(this,0,Event.MOUSE_DOWN,-100,-100,0,0);
            GraphCanvas_.mouseDown(ee,-100,-100);    
            
          }
      };

      QSnames[0]="FileBrowser";
      QSnames[1]="FileName";
      QSnames[2]="GetFile";
      QSnames[3]="PutFile";
      QSnames[4]="Gaussian";
      QSnames[5]="Gamess";
      QSnames[6]="Gaus2pdb";
      QSnames[7]="EditFile";

      for(i=0;i<8;i++) {
         QSbuttons[i] = new Button(QSnames[i]);
         QSbuttons[i].addActionListener(QSlistener);
         QS.add(QSbuttons[i]);
      }

      Modules.add("QS",QS);

      Panel Frog = new Panel();
      Frog.setLayout(new GridLayout(2,2));
      Frog.add(new Button("Input"));
      Frog.add(new Button("Output"));
      Frog.add(new Button("Flip"));
      Frog.add(new Button("Flop"));
      Modules.add("Frog",Frog);

      Panel NewApp = new Panel();
      NewApp.add(new Label("to be added...",Label.CENTER));
      Modules.add("Other",NewApp);

      Creator.add(BorderLayout.CENTER,Modules);

      ActionCards.add("Edit", Creator); 

      Executor = new CPanel(12,"aga.npac.syr.edu");

      ActionCards.add("Run", Executor);

      Panel Savior = new Panel();
      Savior.add(new Label("Save panel goes here"));

      ActionCards.add("Save", Savior);

      Panel Loader = new Panel();
      Loader.add(new Label("Loader Panel goes here"));

      ActionCards.add("Load", Loader);

      Panel Exitor = new Panel();
      Exitor.add(new Label("Exitor Panel goes here"));

      ActionCards.add("Exit", Exitor);

      Panel Stopper = new Panel();
      Stopper.setBackground(Color.cyan);
      Stopper.add(new Label("All backend modules has been destroyed"));

      ActionCards.add("Stop", Stopper);

      add(BorderLayout.CENTER, ActionCards);
   }
   public void showContents() {
      card.last(Modules);
   }
   public void showContents(String what) {
      card.show(Modules,what);
   }

   public void showActionCard (String what) {
      Acard.show(ActionCards,what);
   }

   public void actionPerformed(ActionEvent e) {;}
   public void itemStateChanged(ItemEvent e) {;}

}


